package me.unurled.sacredrealms.sr.commands.admin.cutscene;

import static me.unurled.srcore.utils.Component.NOT_PLAYER;
import static me.unurled.srcore.utils.Component.NO_PERMISSION;
import static me.unurled.srcore.utils.Component.textComp;

import io.papermc.paper.command.brigadier.BasicCommand;
import io.papermc.paper.command.brigadier.CommandSourceStack;
import java.util.Collection;
import java.util.List;
import me.unurled.sacredrealms.sr.components.cutscene.CutsceneManager;
import me.unurled.srcore.api.Manager;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class CreateCutsceneCommand implements BasicCommand {

  private CutsceneManager cm;

  @Override
  public void execute(@NotNull CommandSourceStack sender, String[] args) {
    if (!(sender.getSender() instanceof Player p)) {
      sender.getSender().sendMessage(textComp(NOT_PLAYER));
      return;
    }
    if (!p.hasPermission("sr.cutscene.create")) {
      p.sendMessage(textComp(NO_PERMISSION));
      return;
    }
    // get the name
    if (args.length < 1) {
      p.sendMessage("Usage: /cs <name>");
      return;
    }
    String name = args[0];
    // create the cutscene

    if (cm == null) {
      cm = Manager.getInstance(CutsceneManager.class);
    }

    cm.startCreatingCutscene(p, name);
  }

  @Override
  public Collection<String> suggest(
      CommandSourceStack commandSourceStack, String @NotNull [] args) {
    if (args.length == 1) {
      return List.of("name");
    }
    return BasicCommand.super.suggest(commandSourceStack, args);
  }
}
