package me.unurled.sacredrealms.sr.commands.admin.cutscene;

import static me.unurled.srcore.utils.Component.NO_PERMISSION;
import static me.unurled.srcore.utils.Component.textComp;

import io.papermc.paper.command.brigadier.BasicCommand;
import io.papermc.paper.command.brigadier.CommandSourceStack;
import me.unurled.sacredrealms.sr.components.cutscene.Cutscene;
import me.unurled.sacredrealms.sr.components.cutscene.CutsceneManager;
import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recording;
import me.unurled.srcore.api.Manager;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class RecordCutsceneCommand implements BasicCommand {

  private RecordingManager rm;

  @Override
  public void execute(@NotNull CommandSourceStack stack, String[] args) {
    if (!(stack.getSender() instanceof Player p)) {
      return;
    }

    if (!p.hasPermission("sr.cutscene.create")) {
      p.sendMessage(textComp(NO_PERMISSION));
      return;
    }

    if (rm == null) {
      rm = Manager.getInstance(RecordingManager.class);
    }

    Recording activeRecording = rm.getPlayerActiveRecording(p);
    if (activeRecording != null) {
      p.sendMessage("You are already recording a cutscene.");
      return;
    }

    Cutscene cutscene =
        Manager.getInstance(CutsceneManager.class).getCutsceneBeingCreated(p.getUniqueId());
    if (cutscene == null) {
      p.sendMessage("You are not creating a cutscene.");
      return;
    }
    activeRecording = new Recording(cutscene, p);

    // open menu for selection cutscene
  }
}
