package me.unurled.sacredrealms.sr.commands.admin.cutscene;

import static me.unurled.srcore.utils.Component.NOT_PLAYER;
import static me.unurled.srcore.utils.Component.NO_PERMISSION;
import static me.unurled.srcore.utils.Component.textComp;

import io.papermc.paper.command.brigadier.BasicCommand;
import io.papermc.paper.command.brigadier.CommandSourceStack;
import java.util.Collection;
import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import me.unurled.srcore.api.Manager;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class StopRecordingCommand implements BasicCommand {

  @Override
  public void execute(@NotNull CommandSourceStack stack, String[] args) {
    if (!(stack.getSender() instanceof Player p)) {
      stack.getSender().sendMessage(textComp(NOT_PLAYER));
      return;
    }
    if (!p.hasPermission("sr.cutscene.create")) {
      p.sendMessage(textComp(NO_PERMISSION));
      return;
    }

    Manager.getInstance(RecordingManager.class).stopRecording(p);
  }

  @Override
  public Collection<String> suggest(CommandSourceStack commandSourceStack, String[] args) {
    return BasicCommand.super.suggest(commandSourceStack, args);
  }
}
