package me.unurled.sacredrealms.sr.components.cutscene;

import static me.unurled.srcore.utils.Component.textComp;
import static org.bukkit.Material.RED_WOOL;

import me.unurled.sacredrealms.sr.utils.Region;
import me.unurled.sacredrealms.sr.utils.RegionUtil;
import me.unurled.srcore.api.Manager;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.jetbrains.annotations.NotNull;

public class CreationListener implements Listener {

  private CutsceneManager cm;

  @EventHandler
  public void onInventoryClick(@NotNull InventoryClickEvent e) {
    if (e.getWhoClicked() instanceof Player p) {
      if (cm == null) {
        cm = Manager.getInstance(CutsceneManager.class);
      }

      Cutscene cutscene = cm.getCutsceneBeingCreated(p.getUniqueId());
      if (cutscene == null) {
        return;
      }

      e.setCancelled(true);
    }
  }

  @EventHandler
  public void onRightClick(@NotNull PlayerInteractEvent e) {
    if (!e.getAction().isRightClick()) {
      return;
    }

    Player p = e.getPlayer();
    if (cm == null) {
      cm = Manager.getInstance(CutsceneManager.class);
    }

    Cutscene cutscene = cm.getCutsceneBeingCreated(p.getUniqueId());

    if (cutscene == null) {
      return;
    }
    e.setCancelled(true);

    if (e.getItem() == null) {
      return;
    }

    switch (e.getItem().getType()) {
      case BARRIER -> {
        RegionUtil.killSelectorsWithTag(cutscene.name());
        cm.cancelCreatingCutscene(p);
      }
      case EMERALD_BLOCK -> {
        if (cutscene.pos1() == null) {
          p.sendMessage(textComp("<red>Pos1 not set. Click on Red Wool."));
          return;
        }
        if (cutscene.pos2() == null) {
          p.sendMessage(textComp("<red>Pos2 not set. Click on Blue Wool."));
          return;
        }
        cm.finishCreatingCutscene(p);
        RegionUtil.killSelectorsWithTag(cutscene.name());
      }
      case RED_WOOL, BLUE_WOOL -> {
        Location loc = null;
        if (e.getAction() == Action.RIGHT_CLICK_BLOCK && e.getClickedBlock() != null) {
          loc = e.getClickedBlock().getLocation();
        } else if (e.getAction() == Action.RIGHT_CLICK_AIR) {
          loc = e.getPlayer().getLocation();
        }
        if (e.getItem().getType() == RED_WOOL) {
          p.sendMessage(textComp("<green>Pos1 set."));
          cutscene.setPos1(loc);
        } else {
          p.sendMessage(textComp("<green>Pos2 set."));
          cutscene.setPos2(loc);
        }

        if (cutscene.pos1() != null && cutscene.pos2() != null) {
          Region region = new Region();
          region.setCorner1(cutscene.pos1());
          region.setCorner2(cutscene.pos2());
          if (loc == null) return;
          RegionUtil.killSelectorsWithTag(cutscene.name());
          RegionUtil.drawSelector(region, loc.getWorld(), cutscene.name(), NamedTextColor.GREEN);
          p.sendMessage(
              textComp(
                  "<green>You have set both corners! Right click the Emerald block to finish."));
        } else if (cutscene.pos1() != null && cutscene.pos2() == null) {
          Region region = new Region();
          region.setCorner1(cutscene.pos1());
          region.setCorner2(cutscene.pos1());
          if (loc == null) return;
          RegionUtil.killSelectorsWithTag(cutscene.name());
          RegionUtil.drawSelector(region, loc.getWorld(), cutscene.name(), NamedTextColor.YELLOW);
        } else if (cutscene.pos1() == null && cutscene.pos2() != null) {
          Region region = new Region();
          region.setCorner1(cutscene.pos2());
          region.setCorner2(cutscene.pos2());
          if (loc == null) return;
          RegionUtil.killSelectorsWithTag(cutscene.name());
          RegionUtil.drawSelector(region, loc.getWorld(), cutscene.name(), NamedTextColor.YELLOW);
        }
      }
    }
  }
}
