package me.unurled.sacredrealms.sr.components.cutscene;

import java.util.UUID;
import org.bukkit.Location;
import org.jetbrains.annotations.NotNull;

public class Cutscene {

  private UUID id = UUID.randomUUID();
  private String name;
  private Location pos1;
  private Location pos2;

  public Cutscene() {}

  public Cutscene(String name) {
    this.name = name;
  }

  public Cutscene(UUID id, String name, Location pos1, Location pos2) {
    this.id = id;
    this.name = name;
    this.pos1 = pos1;
    this.pos2 = pos2;
  }

  public boolean isInRegion(@NotNull Location location) {
    double x1 = pos1.getX();
    double x2 = pos2.getX();
    double y1 = pos1.getY();
    double y2 = pos2.getY();
    double z1 = pos1.getZ();
    double z2 = pos2.getZ();
    double x = location.getX();
    double y = location.getY();
    double z = location.getZ();
    return x >= Math.min(x1, x2)
        && x <= Math.max(x1, x2)
        && y >= Math.min(y1, y2)
        && y <= Math.max(y1, y2)
        && z >= Math.min(z1, z2)
        && z <= Math.max(z1, z2);
  }

  public UUID id() {
    return id;
  }

  public Cutscene setId(UUID id) {
    this.id = id;
    return this;
  }

  public String name() {
    return name;
  }

  public Cutscene setName(String name) {
    this.name = name;
    return this;
  }

  public Location pos1() {
    return pos1;
  }

  public Cutscene setPos1(Location pos1) {
    this.pos1 = pos1;
    return this;
  }

  public Location pos2() {
    return pos2;
  }

  public Cutscene setPos2(Location pos2) {
    this.pos2 = pos2;
    return this;
  }
}
