package me.unurled.sacredrealms.sr.components.cutscene;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recording;
import me.unurled.sacredrealms.sr.components.cutscene.tasks.ReplayTask;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitTask;
import org.jetbrains.annotations.NotNull;

public class Replay {
  private final Player viewer;
  private final Recording recording;
  private final BukkitTask replayTask;
  private final Map<UUID, Integer> spawnedEntities;

  public Replay(Recording recording, @NotNull Player viewer) {
    this.recording = recording;
    this.viewer = viewer;
    spawnedEntities = new HashMap<>();

    viewer.getInventory().clear();
    // TODO: control cutscene replay

    replayTask =
        Bukkit.getScheduler()
            .runTaskTimerAsynchronously(SR.getPlugin(), new ReplayTask(this), 0L, 1L);
  }

  public Player viewer() {
    return viewer;
  }

  public Recording recording() {
    return recording;
  }

  public BukkitTask replayTask() {
    return replayTask;
  }

  public void endReplay() {
    if (replayTask != null) {
      replayTask.cancel();
    }
  }

  public Map<UUID, Integer> spawnedEntities() {
    return spawnedEntities;
  }
}
