package me.unurled.sacredrealms.sr.components.cutscene;

import java.util.HashSet;
import java.util.Set;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recording;
import me.unurled.srcore.api.Manager;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class ReplayManager extends Manager {

  private Set<Replay> replays;

  @Override
  public void load() {
    super.load();
    replays = new HashSet<>();
  }

  @Override
  public void unload() {
    super.unload();
  }

  @Nullable
  public Replay getReplayForPlayer(Player player) {
    return replays.stream()
        .filter(replay -> replay.viewer().equals(player))
        .findFirst()
        .orElse(null);
  }

  public void replayRecording(Recording recording, Player player) {
    if (getReplayForPlayer(player) != null) {
      return;
    }

    Replay replay = new Replay(recording, player);
    replays.add(replay);
  }

  public void stopReplay(@NotNull Replay replay) {
    // stop replay taskk
    replay.endReplay();

    replays.remove(replay);
  }

  public Set<Replay> replays() {
    return replays;
  }
}
