package me.unurled.sacredrealms.sr.components.cutscene.recording.recordables;

import com.github.retrooper.packetevents.protocol.player.User;
import com.github.retrooper.packetevents.wrapper.play.server.WrapperPlayServerDestroyEntities;
import java.util.UUID;
import me.unurled.sacredrealms.sr.components.cutscene.Replay;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recordable;
import org.jetbrains.annotations.NotNull;

public class DespawnEntityRecordable extends Recordable {

  private UUID entityId;

  public DespawnEntityRecordable() {}

  public DespawnEntityRecordable(UUID entityId) {
    this.entityId = entityId;
  }

  @Override
  public void replay(@NotNull Replay replay, @NotNull User user) throws Exception {
    WrapperPlayServerDestroyEntities destroyEntities =
        new WrapperPlayServerDestroyEntities(replay.spawnedEntities().get(entityId));
    user.sendPacket(destroyEntities);
    replay.spawnedEntities().remove(entityId);
  }

  public UUID entityId() {
    return entityId;
  }

  public DespawnEntityRecordable setEntityId(UUID entityId) {
    this.entityId = entityId;
    return this;
  }
}
