package me.unurled.sacredrealms.sr.components.cutscene.tasks;

import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recording;
import me.unurled.sacredrealms.sr.components.cutscene.recording.recordables.DespawnEntityRecordable;
import me.unurled.sacredrealms.sr.components.cutscene.recording.recordables.LocationChangeRecordable;
import me.unurled.srcore.api.Manager;
import org.bukkit.Bukkit;
import org.bukkit.entity.Entity;

public class TrackLocationTask implements Runnable {

  private final Recording recording;

  public TrackLocationTask(Recording recording) {
    this.recording = recording;
  }

  @Override
  public void run() {
    var recordebaleEntities = recording.recordableEntities();
    synchronized (recordebaleEntities) {
      recordebaleEntities.forEach(
          uuid -> {
            Entity entity = Bukkit.getEntity(uuid);
            if (entity == null) {
              recording.recordableEntities().remove(uuid);
              DespawnEntityRecordable recordable = new DespawnEntityRecordable(uuid);
              Manager.getInstance(RecordingManager.class).addRecordable(recording, recordable);
              return;
            }

            if (!recording.cutscene().isInRegion(entity.getLocation())) {
              recording.recordableEntities().remove(uuid);
              DespawnEntityRecordable recordable = new DespawnEntityRecordable(uuid);
              Manager.getInstance(RecordingManager.class).addRecordable(recording, recordable);
              return;
            }

            var recordable =
                new LocationChangeRecordable(entity.getUniqueId(), entity.getLocation());

            Manager.getInstance(RecordingManager.class).addRecordable(recording, recordable);
          });
    }
  }
}
