package me.unurled.sacredrealms.sr.components.pointer;

import static me.unurled.sacredrealms.sr.utils.Logger.error;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicInteger;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.srcore.api.Manager;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitTask;

public class PointerManager extends Manager {

  private final Map<UUID, BukkitTask> tasks = new HashMap<>();

  public void startPointing(Player player, Location location) {
    int id = -1;
    try {
      Class<?> entityClass = Class.forName("net.minecraft.world.entity.Entity");
      Field field = entityClass.getDeclaredField("ENTITY_COUNTER");
      field.setAccessible(true);
      AtomicInteger ENTITY_COUNTER = (AtomicInteger) field.get(null);
      id = ENTITY_COUNTER.incrementAndGet();
    } catch (Exception e) {
      error("Failed to find Entity counter field in nms.");
    }
    if (id == -1) {
      return;
    }
    Pointer pointer = new Pointer(id, location);
    DisplayForPlayer task = new DisplayForPlayer(pointer, player);
    BukkitTask btask =
        Bukkit.getScheduler().runTaskTimerAsynchronously(SR.getPlugin(), task, 0, 5L);
    tasks.put(player.getUniqueId(), btask);
  }
}
