package me.unurled.sacredrealms.sr.gui.recordings;

import static me.unurled.sacredrealms.sr.utils.Items.glassPane;

import java.util.ArrayList;
import java.util.List;
import me.unurled.sacredrealms.sr.components.cutscene.Cutscene;
import me.unurled.sacredrealms.sr.components.cutscene.CutsceneManager;
import me.unurled.sacredrealms.sr.gui.BackItem;
import me.unurled.sacredrealms.sr.gui.ForwardItem;
import me.unurled.srcore.api.Manager;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.gui.Gui;
import xyz.xenondevs.invui.gui.PagedGui;
import xyz.xenondevs.invui.gui.structure.Markers;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.builder.ItemBuilder;

public class StartRecordingGui {
  private StartRecordingGui() {}

  public static @NotNull Gui listGui() {
    CutsceneManager cm = Manager.getInstance(CutsceneManager.class);

    List<Item> items = new ArrayList<>();
    for (Cutscene cs : cm.cutscenes()) {
      CutsceneItem item = new CutsceneItem(cs.name(), cs.id());
      items.add(item);
    }

    return PagedGui.items()
        .setStructure(
            "# # # # # # # # #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# # # < # > # # #")
        .addIngredient('#', new ItemBuilder(glassPane()))
        .addIngredient('X', Markers.CONTENT_LIST_SLOT_HORIZONTAL)
        .addIngredient('<', new BackItem())
        .addIngredient('>', new ForwardItem())
        .setContent(items)
        .build();
  }
}
