package me.unurled.sacredrealms.sr.gui.replay;

import static me.unurled.sacredrealms.sr.utils.Items.glassPane;

import java.util.ArrayList;
import java.util.List;
import me.unurled.sacredrealms.sr.components.cutscene.Replay;
import me.unurled.sacredrealms.sr.components.cutscene.ReplayManager;
import me.unurled.sacredrealms.sr.gui.BackItem;
import me.unurled.sacredrealms.sr.gui.ForwardItem;
import me.unurled.srcore.api.Manager;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.gui.Gui;
import xyz.xenondevs.invui.gui.PagedGui;
import xyz.xenondevs.invui.gui.structure.Markers;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.builder.ItemBuilder;

public class ReplayGui {
  private ReplayGui() {}

  public static @NotNull Gui listGui() {
    ReplayManager rm = Manager.getInstance(ReplayManager.class);

    List<Item> items = new ArrayList<>();
    for (Replay r : rm.replays()) {}

    return PagedGui.items()
        .setStructure(
            "# # # # # # # # #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# # # < # > # # #")
        .addIngredient('#', new ItemBuilder(glassPane()))
        .addIngredient('X', Markers.CONTENT_LIST_SLOT_HORIZONTAL)
        .addIngredient('<', new BackItem())
        .addIngredient('>', new ForwardItem())
        .setContent(items)
        .build();
  }
}
